﻿using Syncfusion.Windows.Chart;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace GanttChart
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            FrameworkElementFactory text = new FrameworkElementFactory(typeof(TextBlock));

            text.SetBinding(TextBlock.TextProperty, new Binding("Description"));
            temple.VisualTree = text;
        }
         DataTemplate temple = new DataTemplate();
           
            
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            viewmodel produ = (layout.DataContext as viewmodel);
            (layout.DataContext as viewmodel).Products.Add(new model() { ProdId = (layout.DataContext as viewmodel).Products.Count + 1, Prodname = "Rice", Price = produ.Products[produ.Products.Count / 2].Price, Stock = produ.Products[produ.Products.Count / 2].Stock });

            (layout.DataContext as viewmodel).SeriesAnnotation.m_annotationsCollection.Add(new ChartSeriesAnnotation() { X = produ.Products[produ.Products.Count - 2].ProdId, Y = produ.Products[produ.Products.Count - 1].Stock, Description = "Stage " + produ.Products.Count, Stroke = Brushes.Black, Template = temple });

        }
    }
    public class model : INotifyPropertyChanged
    {
        private double prodId;
        public double ProdId
        {
            set
            {
                this.prodId = value;
                this.RaisePropertyChanged("ProdId");
            }
            get
            {
                return this.prodId;
            }
        }
        private string prodname;
        public string Prodname
        {
            set
            {
                this.prodname = value;
                this.RaisePropertyChanged("Prodname");
            }
            get
            {
                return this.prodname;
            }
        }

        private double price;
        public double Price
        {
            set
            {
                this.price = value;
                this.RaisePropertyChanged("Price");
            }
            get
            {
                return this.price;
            }
        }

        private double stock;
        public double Stock
        {
            set
            {
                this.stock = value;
                this.RaisePropertyChanged("Stock");
            }
            get
            {
                return this.stock;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
    public class viewmodel : INotifyPropertyChanged
    {
        public viewmodel()
        {

            this.SeriesAnnotation = new AnnotationsCollection();

            DataTemplate temple = new DataTemplate();
            FrameworkElementFactory text = new FrameworkElementFactory(typeof(TextBlock));
          
            text.SetBinding(TextBlock.TextProperty, new Binding("Description"));
            temple.VisualTree = text;
            
            this.Products = new ObservableCollection<model>();

            Products.Add(new model() { ProdId = 1, Prodname = "Rice", Price = 20, Stock = 53 });

            SeriesAnnotation.m_annotationsCollection.Add(new ChartSeriesAnnotation() { X = Products[0].ProdId-1, Y = Products[0].Stock , Description = "Stage 1", Stroke = Brushes.Black, Template = temple });

            Products.Add(new model() { ProdId = 2, Prodname = "Wheat", Price = 22, Stock = 76 });

            SeriesAnnotation.m_annotationsCollection.Add(new ChartSeriesAnnotation() { X = Products[1].ProdId-1, Y = Products[1].Stock , Description = "Stage 2", Stroke = Brushes.Black, Template = temple });

            Products.Add(new model() { ProdId = 3, Prodname = "Oil", Price = 30, Stock = 80 });
            SeriesAnnotation.m_annotationsCollection.Add(new ChartSeriesAnnotation() { X = Products[2].ProdId-1, Y = Products[2].Stock, Description = "Stage 3", Stroke = Brushes.Black, Template = temple });

            Products.Add(new model() { ProdId = 4, Prodname = "Corn", Price = 26, Stock = 50 });
            SeriesAnnotation.m_annotationsCollection.Add(new ChartSeriesAnnotation() { X = Products[3].ProdId-1, Y = Products[3].Stock, Description = "Stage 4", Stroke = Brushes.Black, Template = temple });

        }

         public ObservableCollection<model> products;
        public ObservableCollection<model> Products { set
            {
                this.products = value;
                this.RaisePropertyChanged("Products");
            }
            get
            {
                return this.products;
            }
        }

        private AnnotationsCollection seriesAnnotation;
        public AnnotationsCollection SeriesAnnotation 
        {
            set
            {
                this.seriesAnnotation = value;
                this.RaisePropertyChanged("SeriesAnnotation");
            }
            get
            {
                return this.seriesAnnotation;
            }
        }
        
        public event PropertyChangedEventHandler PropertyChanged;

          private void RaisePropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
